<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://saxon.sf.net/" xmlns:file="java:java.io.File">
	<xsl:output method="html" indent="yes"/>
	
	<!-- match root node -->
	<xsl:template match="/">
		<xsl:variable name="file-name" select="file:getName(file:new(string(base-uri())))"/>
		<html>
			<head>
				<title>Asbru Plan Call Hierachy of <xsl:value-of select="$file-name"/></title>
				<style type="text/css">
					<xsl:comment>
						a { text-decoration:none; font-weight:normal; white-space:nowrap; }
						ul { margin-top:-1; margin-bottom:0;}
						ul {list-style-type:disc }
						ul ul {list-style-type:circle }
						ul ul ul {list-style-type:square }
						ul ul ul ul {list-style-type:disc }
						ul ul ul ul ul {list-style-type:circle }
						ul ul ul ul ul ul {list-style-type:square }
						ul ul ul ul ul ul ul {list-style-type:disc }
						ul ul ul ul ul ul ul ul {list-style-type:circle }
						ul ul ul ul ul ul ul ul ul {list-style-type:square}
						ul ul ul ul ul ul ul ul ul ul {list-style-type:disc}
						ul ul ul ul ul ul ul ul ul ul ul {list-style-type:circle}
						ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:square}
						ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:disc}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:circle}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:square}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:disc}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:circle}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:square}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:disc}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:circle}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:square}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:disc}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:circle}
						ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul ul {list-style-type:square}
					</xsl:comment>
				</style>
			</head>
			<body>
				<h2>Summary Plan Call Hierachy of Asbru file <code><xsl:value-of select="$file-name"/></code></h2>
				<xsl:variable name="uncalled-plans" select="//plan[not(@name=//plan-schema/@name)]"/>
					<xsl:if test="count($uncalled-plans) != 1"> more than one possible top-level plan, use first one<br></br></xsl:if>
					<xsl:apply-templates select="$uncalled-plans[1]" mode="call"/>					
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="plan">
		<li><xsl:call-template name="call-plan"/></li>
	</xsl:template>
	<xsl:template match="plan" mode="call" name="call-plan">
		plan <B><a href="{saxon:path()}"><xsl:value-of select="@name"/></a></B> (<xsl:value-of select="node-name(plan-body/*[last()])"/>)
		<xsl:if test="not(plan-body/user-performed) and plan-body/*">
		<ul>
			<xsl:apply-templates select="plan-body/*"/>
		</ul></xsl:if>
	</xsl:template>
	<xsl:template match="subplans">
		<li><a href="{saxon:path()}">subplans</a> (<xsl:value-of select="@type"/>, wait-for=<xsl:value-of select="if (wait-for/all or wait-for/one or wait-for/none) then node-name(wait-for/*[1]) else if (wait-for/cardinality/numerical-constant) then wait-for/cardinality/numerical-constant/@value else '*'"/>, wfos=<xsl:value-of select="@wait-for-optional-subplans"/>, ras=<xsl:value-of select="@retry-aborted-subplans"/>)
			<ul>
				<xsl:apply-templates select="*"/>
			</ul>
		</li>
	</xsl:template>	
	<xsl:template match="plan-activation">
		<li>
			<a href="{saxon:path()}">call</a> to <xsl:apply-templates select="//plan[@name=current()/plan-schema/@name]" mode="call"/>
		</li>
	</xsl:template>
		<xsl:template match="if-then-else">
		<li><a href="{saxon:path()}">if-then-else</a>
			<ul>
				<xsl:apply-templates select="then-branch/*"/>
				<xsl:apply-templates select="else-branch/*"/>
			</ul>
		</li>
	</xsl:template>
	<xsl:template match="cyclical-plan">
		<li><a href="{saxon:path()}">cyclical-plan</a>
			<ul>
				<xsl:apply-templates select="cyclical-plan-body/*"/>
			</ul>
		</li>
	</xsl:template>
	<xsl:template match="set-context"><li><a href="{saxon:path()}">set-context</a></li></xsl:template>
	<xsl:template match="ask"><li><a href="{saxon:path()}">ask</a> (p:<xsl:value-of select="parameter-ref/@name"/>)</li></xsl:template>
	<xsl:template match="variable-assignment"><li><a href="{saxon:path()}">variable-assignment</a> (v:<xsl:value-of select="@variable"/>)</li></xsl:template>
	<xsl:template match="parameter-assignment"><li><a href="{saxon:path()}">parameter-assignment</a> (p:<xsl:value-of select="@parameter"/>)</li></xsl:template>
</xsl:stylesheet>
