<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:file="java:java.io.File">
	<xsl:output method="html" indent="yes"/>

	<xsl:template match="/">
		<xsl:variable name="file-name" select="file:getName(file:new(string(base-uri())))"/>
		<html>
			<head>
				<title>Usage of elements in file <xsl:value-of select="$file-name"/></title>
			</head>
			<body>
				<table border="1">
				<tr><th colspan="2">Usage of elements in file <code><xsl:value-of select="$file-name"/></code></th></tr>
				<xsl:variable name="all-elements" select="//*"/>			
				<tr><th>Element</th><th>Occurrences</th></tr>
				<xsl:for-each-group select="$all-elements" group-by="node-name()">
					<xsl:sort select="string(node-name())"/>
					<tr>
						<td><xsl:value-of select="node-name()"/></td>
						<td><xsl:value-of select="count(current-group())"/></td>
					</tr>
				</xsl:for-each-group>
				<tr>
					<td><xsl:value-of select="count(distinct-values(for $n in $all-elements return string(node-name($n))))"/></td>
					<td><xsl:value-of select="count($all-elements)"/></td>
				</tr>
				</table>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
